/*
 * @(#)CustomerBusinessLogic.java
 *
 * Copyright 2005 Mamezou, co., ltd. All rights reserved.
 * Use is subject to license terms.
 */
package com.mamezou.webdbpress26.tutorial.businesslogic;

import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import com.mamezou.webdbpress26.tutorial.dataaccess.CustomerDataAccess;
import com.mamezou.webdbpress26.tutorial.dataaccess.CustomerEntity;

/**
 * ql̃rWlXWbNłB
 * 
 * @author Hirofumi Iwasaki
 * @version 1.0
 */
public class CustomerBusinessLogic {

    /**
     * qlo^܂B
     * @param customer
     * @throws BusinessLogicException rWlXWbNOł
     * @throws UniqueConstraintException ӐOł
     */
    public void register(CustomerEntity customer) 
            throws BusinessLogicException, UniqueConstraintException {

        Connection conn = null;
        try {
            conn = this.getConnection();
            conn.setAutoCommit(false);
            CustomerDataAccess customerDA = new CustomerDataAccess();
            
            // qlāAID݂Γo^܂B
            CustomerEntity selected = customerDA.retrieve(customer.getId(), conn);
            
            if (selected != null) {
                throw new UniqueConstraintException();
            }
            // ID΂qlo^܂B
            customerDA.create(customer, conn);
            
            conn.commit();
            
        } catch (SQLException e) {
            try {
                if (conn != null) {
                    conn.rollback();
                }
            } catch (SQLException ex) {
                throw new RuntimeException(ex.getMessage());
            }
            e.printStackTrace();
            throw new BusinessLogicException();
        } catch (NamingException e) {
            try {
                if (conn != null) {
                    conn.rollback();
                }
            } catch (SQLException ex) {
                throw new RuntimeException(ex.getMessage());
            }
            e.printStackTrace();
            throw new BusinessLogicException();
        } finally {
            try {
                if (conn != null) {
                    conn.close();
                }
            } catch (SQLException e) {
                e.printStackTrace();
                throw new RuntimeException(e.getMessage());
            }
        }

    }
    
    /**
     * DB Connection擾܂
     * @return Connection
     * @throws SQLException SQLOł
     * @throws NamingException OOł
     */
    protected Connection getConnection() throws SQLException, NamingException {
        
        Context initContext = new InitialContext();
        Context envContext = (Context) initContext.lookup("java:comp/env");
        DataSource ds = (DataSource) envContext.lookup("jdbc/postgres");
        Connection conn = ds.getConnection();
        return conn;
    }
}
