/*
 * @(#)CustomerDataAccess.java
 *
 * Copyright 2005 Mamezou, co., ltd. All rights reserved.
 * Use is subject to license terms.
 */
package com.mamezou.webdbpress26.tutorial.dataaccess;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * qlEntityf[^x[XɉiE܂B
 * 
 * @author Hirofumi Iwasaki
 * @version 1.0
 */
public class CustomerDataAccess {

    /**
     * CUSTOMERe[uINSERT܂
     * @param customer CustomerEntity
     * @param conn Connection
     * @throws SQLException
     */
    public void create(CustomerEntity customer, Connection conn) throws SQLException {

        String insertStatement = "INSERT INTO CUSTOMER (ID, PASSWORD, " +
        		"NAME_KANJI, NAME_KANA, POSTAL_CODE, ADDRESS, " +
        		"TELEPHONE, EMAIL_ADDRESS, REGISTER_TIMESTAMP, UPDATE_TIMESTAMP) " +
        		"VALUES (?,?,?,?,?,?,?,?,CURRENT_TIMESTAMP,CURRENT_TIMESTAMP)";
        PreparedStatement statement 
        	= conn.prepareStatement(insertStatement);
        statement.setString(1, customer.getId());
        statement.setString(2, customer.getPassword());
        statement.setString(3, customer.getNameKanji());
        statement.setString(4, customer.getNameKana());
        statement.setString(5, customer.getPostalCode());
        statement.setString(6, customer.getAddress());
        statement.setString(7, customer.getTelephone());
        statement.setString(8, customer.getEmailAddress());
        
        try {
            int result = statement.executeUpdate();
        } finally {
            if (statement != null) {
                statement.close();
            }
        }
    }

    /**
     * CUSTOMERe[uSELECT܂
     * @param id String
     * @param conn Connection
     * @return CustomerEntity
     * @throws SQLException
     */
    public CustomerEntity retrieve(String id, Connection conn) 
            throws SQLException {
        
        if (id == null || conn == null) {
            throw new NullPointerException("PARAMETER IS NULL.");
        }

        String selectStatement = "SELECT ID, PASSWORD, NAME_KANJI," +
                "NAME_KANA, POSTAL_CODE, ADDRESS , TELEPHONE," +
                "EMAIL_ADDRESS, REGISTER_TIMESTAMP, UPDATE_TIMESTAMP" +
                " FROM CUSTOMER WHERE ID=?";
        
        PreparedStatement statement
            = conn.prepareStatement(selectStatement);
        statement.setString(1, id);
        
        CustomerEntity customer = null;
        ResultSet result = null;
        try {
            result = statement.executeQuery();
            while (result.next()) {
                customer = new CustomerEntity();
                customer.setId(result.getString("ID"));
                customer.setPassword(result.getString("PASSWORD"));
                customer.setNameKanji(result.getString("NAME_KANJI"));
                customer.setNameKana(result.getString("NAME_KANA"));
                customer.setPostalCode(result.getString("POSTAL_CODE"));
                customer.setAddress(result.getString("ADDRESS"));
                customer.setTelephone(result.getString("TELEPHONE"));
                customer.setEmailAddress(result.getString("EMAIL_ADDRESS"));
                customer.setRegisterTimestamp(result.getTimestamp("REGISTER_TIMESTAMP"));
                customer.setUpdateTimestamp(result.getTimestamp("UPDATE_TIMESTAMP"));
            }
        } finally {
            if (result != null) {
                result.close();
            }
            if (statement != null) {
                statement.close();
            }
        }
        return customer;
    }
    
}
